#include <stdio.h>

/* (a) podzadatak */

/* vraca mjeru dva broja dobivenu Euklidovim algoritmom */
int GCD(int x, int y){
    if (x<0) x*=-1;
    if (y<0) y*=-1;
    int temp;
    while(y){
        temp=x%y; x=y; y=temp;
    }
    return x;
}

/* vraca broj razlicitih prostih faktora */
int brojprostihfaktora(int x){
    int br=0, p=2;
    if (x<0) x*=-1;
    if (x==0 || x==1) return 0;
    while(x>1){
        if(x%p==0) br++;
        while(x%p==0){
            x/=p;
        }
        p++;
    }
    return br;
}

void promjenaA(int *x, int *y){
    int novix=2*(*x+*y), noviy=3*(*x-3**y);
    if (novix<0) novix*=-1; if (noviy<0) noviy*=-1;
    *x=novix, *y=noviy;
    return;
}

void promjenaB(int *x, int *y){
    int novix=GCD(*x,*y), noviy=brojprostihfaktora(*y);
    *x=novix, *y=noviy;
    return;
}


/* (b) podzadatak */

/* primamo dodatna dva varijabilna argumenta preko kojih vracano nove vrijednosti*/
int transformacija(int x, int y, int *novix, int *noviy){
    *novix=x; *noviy=y;
    int n=0;
    char z;
    while(1){
        scanf("%c", &z); n++;
        if (z!='A' && z!='B') return n;
        if (z=='A'){
            promjenaA(novix, noviy);
        }
        else promjenaB(novix, noviy);
    }
}

/* (c) podzadatak */

int main(){
    int x,y,n,novix,noviy;
    scanf("%d %d ", &x, &y);
    n=transformacija(x,y,&novix, &noviy);
    printf("%d %d %d %d %d\n",x, y, novix, noviy, n);
    return 0;
}
