#include <stdio.h>

/* (a) podzadatak */

/* vraca mjeru dva broja dobivenu Euklidovim algoritmom */
int GCD(int a, int b){
    if (a<0) a*=-1;
    if (b<0) b*=-1;
    int temp;
    while(b){
        temp=a%b; a=b; b=temp;
    }
    return a;
}

/* vraca najveci prost faktor */
int maxprostfaktor(int a){
    if (a<0) a*=-1;
    if (a==0 || a==1) return 1;
    int p=2;
    while(a>1){
        while(a%p==0){
            a/=p;
        }
        p++;
    }
    /* u zadnjem prolasku smo nepotrebno povecali p pa moramo vratiti p-1 */
    return p-1;
}

void transformacija1(int *a, int *b){
    int novia=maxprostfaktor(*a), novib=GCD(*a, *b);
    *a=novia, *b=novib;
    return;
}

void transformacija2(int *a, int *b){
    int novia=2*(*a-6**b), novib=4*(*a+*b);
    if (novia<0) novia*=-1;
    if (novib<0) novib*=-1;
    *a=novia, *b=novib;
    return;
}


/* (b) podzadatak */

/* primamo dodatna dva varijabilna argumenta preko kojih vracano nove vrijednosti*/
int promjena(int a, int b, int *novia, int *novib){
    *novia=a; *novib=b;
    int n=0, x;
    while(1){
        scanf("%d", &x);
        if (x!=1 && x!=2) return n;
        if (x==1){
            transformacija1(novia, novib);
        }
        else transformacija2(novia, novib);
        n++;
    }
}

/* (c) podzadatak */

int main(){
    int a,b,n,novia,novib;
    scanf("%d %d", &a, &b);
    n=promjena(a,b,&novia, &novib);
    printf("%d %d %d %d %d\n",a,b,novia, novib, n);
    return 0;
}
